state_gameover = newState({100/255, 100/255, 100/255})

local title_font = love.graphics.newFont(60)
local title_text = 'GAME OVER'
local font = love.graphics.newFont(20)
local text = ''
local messages = {
  "You look fine... Trust me.",
  'No traces... unlike cremation.',
  "Oh, come on. That didn't hurt at all.",
  'You scream like a girl.',
  'I expected you to last longer.',
  'How disappointing. I bet more on you.'
}

local menu = {}
local input = {}
local score = 0
local scream = {}
for i = 1, 7 do
  table.insert(scream, love.audio.newSource('sfx/aargh' .. i .. '.ogg', 'static'))
end

function state_gameover.load(params)
  score = params
  menu = newMenu(love.graphics.newFont(25), 10)
  input = {}
  
  text = messages[love.math.random(#messages)]

  if state_highscores.isObtained(score) then
    input = newTextInput(love.graphics.newFont(50), 60, 370, 10)
    menu.addButton('Enter Name', love.graphics.getWidth() / 2, 510,
      function()
        if input.text:len() > 0 then
          state_highscores.enter(input.text, score)
          state_machine.change(state_highscores, true)
        end
      end
    )
  else
    text = 'You poor thing. That must have hurt.'
    menu.addButton('Play Again', love.graphics.getWidth() / 2, 450,
      function()
        state_machine.change(state_play)
      end
    )
    menu.addButton('Exit to Menu', love.graphics.getWidth() / 2, 510,
      function()
        state_machine.change(state_title)
      end
    )
  end
  
  local rscream = love.math.random(#scream)
  scream[rscream]:stop()
  scream[rscream]:play()
end

function state_gameover.update(dt)
  if state_highscores.isObtained(score) then
    input.update(dt)
  end
end

function state_gameover.draw()
  love.graphics.setColor(0, 0, 0, 0.75)
  love.graphics.rectangle('fill', 0, 0, love.graphics.getWidth(), love.graphics.getHeight())

  love.graphics.setColor(1,1,1)

  love.graphics.setFont(title_font)
  love.graphics.printf(title_text, 0, love.graphics.getHeight() / 4, love.graphics.getWidth(), 'center')

  love.graphics.setFont(font)
  love.graphics.printf(text, 0, love.graphics.getHeight() / 2, love.graphics.getWidth(), 'center')
  
  if state_highscores.isObtained(score) then
    input.draw()
  end
  
  menu.draw()
end

function state_gameover.keypressed(key)
  if key == 'return' then
    menu.button_press()
  elseif key == 'up' or key == 'down' or key == 'left' or key == 'right' then
    menu.cycle_down()
  end
  if state_highscores.isObtained(score) then
    input.keypressed(key)
  end
end
function state_gameover.keyreleased(key)
  if key == 'return' then
    menu.button_release()
  end
end
function state_gameover.textinput(t)
  if state_highscores.isObtained(score) and t ~= ' ' and t ~= '\\' then
    input.textinput(t)
  end
end

function state_gameover.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
end
function state_gameover.mousepressed(x, y, button)
  menu.button_press()
end
function state_gameover.mousereleased(x, y, button)
  menu.button_release()
end
