state_play = newState({100/255, 100/255, 100/255})

local score = 0
local counter = 0
local font = love.graphics.newFont(20)

function state_play.load()
  score = 0
  player.initialize()
  walls.initialize(46, 'WASD or ARROWS')
end

function state_play.update(dt)
  counter = counter + dt
  if counter >= 1 then
    score = score + 1
    counter = 0
  end

  player.update(dt)
  walls.update(dt)
  
    if player.y - player.size / 2 < walls.up[1].y + walls.size then
      player.y = walls.up[1].y + walls.size + player.size / 2
    end
    if player.y + player.size / 2 > walls.down[1].y then
      player.y = walls.down[1].y - player.size / 2
    end
    if player.x - player.size / 2 < walls.left[1].x + walls.size then
      player.x = walls.left[1].x + walls.size + player.size / 2
    end
    if player.x + player.size / 2 > walls.right[1].x then
      player.x = walls.right[1].x - player.size / 2
    end
  
  for _, v in pairs(lasers) do
    if getCircleRectangleDistance(player.x, player.y, player.size / 2, v.x, v.y, v.w, v.h) < 0 and v.life > 0.5 then
      state_machine.push(state_gameover, score)
    end
  end
end

function state_play.draw()
  player.draw()
  walls.draw()
  love.graphics.setFont(font)
  love.graphics.setColor(0,0,0)
  love.graphics.printf('Score:\n' .. score, 0, 540, love.graphics.getWidth(), 'center')
end

function state_play.keypressed(key)
  if key == 'escape' then
    state_machine.push(state_pause)
  end
end
