state_title = newState({100/255, 100/255, 100/255})

local menu = newMenu(love.graphics.newFont(40), 10)
local font = love.graphics.newFont(100)
local text = 'LASER CELL'

menu.addButton('Play', love.graphics.getWidth() / 2, 300,
  function()
    state_machine.change(state_play)
  end
)
menu.addButton('High Scores', love.graphics.getWidth() / 2, 400,
  function()
    state_machine.change(state_highscores, false)
  end
)
menu.addButton('Exit', love.graphics.getWidth() / 2, 500,
  function()
    love.event.quit()
  end
)

function state_title.draw()
  love.graphics.setFont(font)
  love.graphics.printf('Laser Cell', 0, 50, love.graphics.getWidth(), 'center')
  menu.draw()
end

function state_title.keypressed(key)
  if key == 'return' or key == 'space' then
    menu.button_press()
  elseif key == 'left' or key == 'up' then
    menu.cycle_up()
  elseif key == 'right' or key == 'down' then
    menu.cycle_down()
  end
end
function state_title.keyreleased(key)
  if key == 'return' or key == 'space' then
    menu.button_release()
  end
end

function state_title.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
end
function state_title.mousepressed(x, y, button)
  if button == 1 then menu.button_press() end
end
function state_title.mousereleased(x, y, button)
  if button == 1 then menu.button_release() end
end
